#ifndef ADSRWIDGET_H
#define ADSRWIDGET_H
#include "adsrwidget.uic.h"

#include "knobwidget.h"

#include "envelope.h"
#include "observer.h"
#include "simsam.h"
#include "sample.h"

class ADSRWidget : public UI_ADSRWidget, public Observer {

  Q_OBJECT;

private:

  int cAttackTime;
  int cDecayTime;
  int cReleaseTime;
  
  int cAttackLevel;
  int cSustainLevel;
  
  EnvADSR *adsr;
  Sample *sample;
  
 public:
  ADSRWidget( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  ~ADSRWidget();
  
  void subjectDeleted(Subject* s);
  void update(Subject* s);
  
  public slots:

  void setSample(Sample* s);
    
  void attackTimeChanged(int v);
  void decayTimeChanged(int v);
  void releaseTimeChanged(int v);
  
  void attackLevelChanged(int v);
  void sustainLevelChanged(int v);
};

#endif // ADSRWIDGET_H
