#ifndef INSTRUMENTSELECTOR_H
#define INSTRUMENTSELECTOR_H
#include "instrumentselector.uic.h"

#include <qcombobox.h>
#include <qlineedit.h>
#include <qspinbox.h>

#include "observer.h"
#include "instrument.h"

class InstrumentSelector : public InstrumentSelectorUI, public Observer {

  Q_OBJECT;
  
  Instrument *instrument;

  void buildOutputList();
  
public:
  InstrumentSelector(QWidget* parent = 0, const char* name = 0, WFlags fl = 0);
  ~InstrumentSelector();

  void subjectDeleted(Subject *s);
  void update(Subject *s);
  
  public slots:
    
  void instrumentSelected(int i);
  void channelSelected(int i);
  void nameEntered();
  void outputSelected(int i);

 signals:
  void instrumentChanged(Instrument* i);
  
};

#endif // INSTRUMENTSELECTOR_H
