#include <qpushbutton.h>
#include <qspinbox.h>
#include <qapplication.h>

#include "midilearndialog.h"
#include "simsam.h"

extern QApplication *qApplication;

/* 
 *  Constructs a MidiLearnDialog which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
MidiLearnDialog::MidiLearnDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : MidiLearnDialogUI( parent, name, modal, fl )
{

  running = TRUE;

  /*
  connect(pbOk,SIGNAL(clicked()),this,SLOT(accept()));
  connect(pbCancel,SIGNAL(clicked()),this,SLOT(reject()));
  */

  connect(pbOk,SIGNAL(clicked()),this,SLOT(okPressed()));
  connect(pbCancel,SIGNAL(clicked()),this,SLOT(cancelPressed()));

}

/*  
 *  Destroys the object and frees any allocated resources
 */
MidiLearnDialog::~MidiLearnDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

void MidiLearnDialog::setNote(int note) {

  sbNote->setValue(note);
}

int MidiLearnDialog::getNote() {

  return(sbNote->value());
}

/*
MidiLearnDialog *midiLearnDialog = NULL;

void *pollNoteWrapper(void*) {
  
  midiLearnDialog->pollNote();
  return(NULL);
}


int MidiLearnDialog::startPolling() {
  
  pollFlag = true;
  midiLearnDialog = this;
  return(pthread_create(&pollNoteHandle, NULL, pollNoteWrapper, NULL));
}


int MidiLearnDialog::stopPolling() {

  pollFlag = false;
  //  return(pthread_cancel(pollNoteHandle));
  return 0;
}
*/

/* this thread polls the last played midi note and updates the dialog... */

/*
//void MidiLearnDialog::pollNote() {
void MidiLearnDialog::run() {

  Simsam::midi->lastNotePlayed = -1;

  while(1) {
    
    if (Simsam::midi->lastNotePlayed != -1) {

      qApplication->lock();
      sbNote->setValue(Simsam::midi->lastNotePlayed); 
      qApplication->unlock();
    }

    sleep(1);
  }
}
*/




void MidiLearnDialog::okPressed(){

  running = FALSE;
  accept();
}

void MidiLearnDialog::cancelPressed(){

  running = FALSE;
  reject();
}



