#ifndef SAMPLESELECTOR_H
#define SAMPLESELECTOR_H
#include "sampleselector.uic.h"

#include <qlistbox.h>
#include <qpushbutton.h>

#include "observer.h"
#include "instrument.h"

class SampleSelector : public SampleSelectorUI, public Observer {

  Q_OBJECT;

  Instrument *instrument;

  void buildSampleList();

 public:
  SampleSelector( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  ~SampleSelector();

  void update(Subject* s);
  void subjectDeleted(Subject* s);

 public slots:
  void addSample();
  void delSample();
  void selectSample(int i);

  void setInstrument(Instrument* i);

 signals:
  void sampleSelected(Sample *s);
  
};

#endif // SAMPLESELECTOR_H
