#ifndef _SAMPLEVIEW_H
#define _SAMPLEVIEW_H

#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>

#include "sample.h"
#include "observer.h"

#define SV_NUM_BUFFERS 2

#define SV_MODE_LOOP 0
#define SV_MODE_TRIM 1

class SampleView : public QWidget, public Observer {

  float* buffers[SV_NUM_BUFFERS];

  Q_OBJECT;

  Sample* sample;
  QPixmap* pixmap;

  int selectionMode;
  int bufferLen;

  float W_stepSize();

  float scaleFactor;
  
  int viewStart;
  int viewEnd;

  void renderPixmap();

  int windowToSample(int x);
  int sampleToWindow(int x);


 public:
  
  SampleView(QWidget* parent = NULL, const char* name = NULL);

  void update(Subject* s);  
  void subjectDeleted(Subject* s);

  void paintEvent(QPaintEvent* e);
  void mousePressEvent(QMouseEvent* e);
  void wheelEvent(QWheelEvent* e);
  void mouseMoveEvent(QMouseEvent* e);

 public slots:
    
  void setSample(Sample* s);
  void setSelectionMode(int v);
  void setLoop();
  void setTrim();

};



#endif // _SAMPLEVIEW_H
