#ifndef ENVELOPE_H
#define ENVELOPE_H

#include "observer.h"

class EnvADSR : public Subject {

  int attackTime;
  int decayTime;
  int releaseTime;

  int attackTimeMS;
  int decayTimeMS;
  int releaseTimeMS;

  float attackLevel;
  int iAttackLevel;

  float sustainLevel;
  int iSustainLevel;

  float atkDelta;
  float decDelta;
  float relDelta;

  int counter;
  float value;

  int state;
  float delta;

 public:

  EnvADSR();

  void setAttackTime(int v);
  void setAttackLevel(int v);
  void setDecayTime(int v);
  void setSustainLevel(int v);
  void setReleaseTime(int v);

  int getAttackTime();
  int getAttackLevel();
  int getDecayTime();
  int getSustainLevel();
  int getReleaseTime();

  void noteOn();
  void noteOff();

  /**
   * Calculates the current amplification factor and increments the counter. The result is stored in s. 
   * Returns false if the envelope is done with release
   */
  bool tick(float *s);

  void calcDeltas();

  //  void setAll(int aTime, int aLev, int dTime, int sLev, int rTime);

  void release();

  void copyTo(EnvADSR *to);

  void resetCounter();

  enum {
    
    OFF,
    ATTACK,
    DECAY,
    SUSTAIN,
    RELEASE
  };

};

#endif // ENVELOPE_H

/*
  $Id: envelope.h,v 1.2 2004-01-29 01:35:12 chenz Exp $
*/
