#ifndef INSTRUMENT_H
#define INSTRUMENT_H

#include <list>

#include "observer.h"
#include "output.h"

class Sample;

class SampleMap : public Subject {

  Sample *samples[120];
  
public:
  
  SampleMap();

  void setSample(int note, Sample *s);
  Sample *getSample(int note);
  void clearSample(Sample *s);
  void clearAll();
};


class Instrument : public Subject {

  char name[128];

  std::list<Sample *> sampleList;

  int outputNum;
  int midiChannel;

  Output *output;

 public:

  static int currentId;

  static Instrument instruments[16];
  static Instrument* getInstrument(int iNum);

  static int init();

  static void unload();

  // sample management...

  void addSample();

  void addSample(Sample *s);

  void removeSample(Sample *s);

  void removeAllSamples();

  Instrument();

  SampleMap sampleMap;
  Sample* getSample(int i);

  const char* getName();
  void setName(const char *);
  
  int getOutputNum();
  void setOutputNum(int oNum);

  int getNumSamples();

  void setMidiChannel(int c);
  int getMidiChannel();
};



#endif // INSTRUMENT_H
