#ifndef _MIDI_H
#define _MIDI_H

#define ALSA_PCM_OLD_HW_PARAMS_API
#define ALSA_PCM_OLD_SW_PARAMS_API

#include <alsa/asoundlib.h>
#include <pthread.h>

#include "instrument.h"

class InstrumentMap;

class Midi {

  static snd_seq_t *seqHandle;

  static pthread_t threadHandle; 

  static int update();

  static void* midiThread(void *);

 public:


  static void noteOn(int c, int n, int v);
  static void noteOff(int c, int v);

  static InstrumentMap instrumentMap;

  static int lastNotePlayed;

  static int init();

};


class InstrumentMap {

  Instrument *instruments[16];
  
public:
  
  InstrumentMap();

  void setInstrument(int channel, Instrument *s);
  Instrument *getInstrument(int channel);
  void clearInstrument(Instrument *s);
  void clearAll();
};


#endif // _MIDI_H


