#include <set>

#include "observer.h"
#include "error.h"

Observer::Observer(Subject *s) {
  
  subject = s;
  if (s) s->addObserver(this);
}


/*
Observer::~Observer() {
  
  subject->removeObserver(this);
}
*/

void Subject::notify(Observer *o) {

  std::set<Observer *>::iterator it;
  
  for(it = observers.begin(); it != observers.end(); it++) {

    // only notify if different from notifier
    // if (*it != o) (*it)->update(this);

    (*it)->update(this);
  }
}

int Subject::addObserver(Observer *o) {

  observers.insert(o);
  return(0);
}

int Subject::removeObserver(Observer *o) {

  observers.erase(o);
  return(0);
}

Subject::~Subject() {

  std::set<Observer *>::iterator it;
  
  for(it = observers.begin(); it != observers.end(); it++) {

    (*it)->subjectDeleted(this);
  }
}
