#ifndef OBSERVER_H
#define OBSERVER_H

/* An implementation of the observer pattern */

#include <set>

class Subject;

class Observer {

  Subject *subject;

 public:
  virtual void update(Subject *s) = 0;
  virtual void subjectDeleted(Subject *s) = 0;

  Observer(Subject *s = NULL);
  //virtual ~Observer();
};


class Subject {

  std::set<Observer *> observers;

 public:

  ~Subject();

  void notify(Observer *o = NULL);
  int addObserver(Observer *o);
  int removeObserver(Observer *o);
};

#endif // OBSERVER_H
