#ifndef _SIMSAM_H
#define _SIMSAM_H

#include <pthread.h>

#define SIMSAM_OUTPUT_ALSA 0
#define SIMSAM_OUTPUT_JACK 1
#define SIMSAM_MIDI_MAP_OFFSET 24
#define SIMSAM_MAX_SAMPLES 128
#define SIMSAM_MAX_VOICES 32
#define SIMSAM_MAX_OUTPUTS 4

class Simsam { 

  static pthread_mutex_t mutex;
  
 public:

  static void lock();
  static void unlock();

  static int init();

  static int load(const char*);
  static int save(const char*);

  static bool framesToMs(int frames, int *ms);
  static bool msToFrames(int ms, int *frames);

  static void panic();
};

#endif // _SIMSAM_H










